#include "stdafx.h"
#include "resource.h"
#include "ccssa.h"
#include <Commdlg.h>
#include <math.h>
#define MAX_LOADSTRING 100
//#define SHIA_SPECIAL 1

// Global Variables:
HINSTANCE hInst;
TCHAR szTitle[MAX_LOADSTRING];
TCHAR szWindowClass[MAX_LOADSTRING];


// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

HBITMAP hShia;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG msg;
	HACCEL hAccelTable;

	lstrcpy( szTitle, APP_NAME );
	LoadString(hInstance, IDC_CCSSA, szWindowClass, MAX_LOADSTRING);
#ifdef SHIA_SPECIAL
	hShia = LoadBitmap( hInstance, MAKEINTRESOURCE( IDB_BITMAP1 ) );
#else
	hShia = LoadBitmap( hInstance, MAKEINTRESOURCE( IDB_BITMAP2 ) );
#endif
	MyRegisterClass(hInstance);

	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_CCSSA);

	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}


	return msg.wParam;
}



ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE( IDI_ICON3 ) );
#ifdef SHIA_SPECIAL
	wcex.hCursor		= LoadCursor( hInstance, MAKEINTRESOURCE(IDC_CURSOR1) );
#else
	wcex.hCursor		= LoadCursor( NULL, IDC_CROSS );
#endif
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_CCSSA;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_ICON3);

	return RegisterClassEx(&wcex);
}


HBITMAP GetClipboardHBitmap( HWND hWnd )
{
	OpenClipboard( hWnd );
	HBITMAP hBitmap = (HBITMAP) GetClipboardData( CF_BITMAP );
	CloseClipboard();
	return hBitmap; // NULL if failed
}



BOOL AdjustWindowSize( HWND hWnd, int cx1, int cy1, RECT * lpPicRect )
{

	if( cx1 > 720 ) cx1 = 720;
	if( cy1 > 480 ) cy1 = 480;

	lpPicRect->left = 0;
	lpPicRect->right = lpPicRect->left + cx1;
	lpPicRect->top = 0;
	lpPicRect->bottom = lpPicRect->top + cy1;
	
	if( cx1 < 480 ) cx1 = 480;

	int cx = cx1 + GetSystemMetrics( SM_CXSIZEFRAME ) * 2;
	int cy = cy1 + 200 + GetSystemMetrics( SM_CYCAPTION ) + GetSystemMetrics( SM_CYMENU )
		+ GetSystemMetrics( SM_CYSIZEFRAME ) * 2;

	RECT winRect;
	GetWindowRect( hWnd, &winRect );

	return MoveWindow( hWnd, winRect.left, winRect.top, cx, cy, TRUE );

}


BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{

   hInst = hInstance; // Store instance handle in our global variable

   HWND hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_BORDER,
      CW_USEDEFAULT, CW_USEDEFAULT, 400, 300, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }


   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}


COLORREF GetAverageColorref( DWORD colorSamples[], UINT uSamplingIdx )
{				
	unsigned long sumB = 0;
	unsigned long sumG = 0;
	unsigned long sumR = 0;
	unsigned int i;
	int b, g, r;
	for( i = 0; i < uSamplingIdx; i++ )
	{
		sumB += GetBValue( colorSamples[ i ] );
		sumG += GetGValue( colorSamples[ i ] );
		sumR += GetRValue( colorSamples[ i ] );
	}
	b = (int) floor(       (double) sumB / uSamplingIdx + 0.5 );
	g = (int) floor(       (double) sumG / uSamplingIdx + 0.5 );
	r = (int) floor(       (double) sumR / uSamplingIdx + 0.5 );

	return ( b * 256 * 256 + g * 256 + r );
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	static HGLOBAL hMemBmpInfo;
	static LPBITMAPINFO lpBmpInfo;

	static HGLOBAL hMemBmpImage;
	static LPVOID lpBmpImage;

	static BOOL bBmpLoaded;

	static COLORREF colorref = 0xffffff;
	static RECT picRect;
	static RECT redrewRect;
	static RECT redrewRect2;
	static SIZE size;
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	static char szColorCode[1000] = "&Hffffff&";

	static HANDLE hFile = NULL;
	static char lpstrFileTitle[ MAX_PATH + 1 ] = "(no data)";

	static int iMouseX;
	static int iMouseY;

	static unsigned int uSamplingIdx = 0;
	static COLORREF colorSamples[ 20 ];
	static BOOL flagSamplingReset = FALSE;

	switch (message) 
	{
		case WM_CREATE:
		{
			hMemBmpInfo = GlobalAlloc( GHND,  1024 );
			hMemBmpImage = GlobalAlloc( GHND,  1024 );
			lpBmpInfo = (LPBITMAPINFO) GlobalLock( hMemBmpInfo );
			lpBmpImage = GlobalLock( hMemBmpImage );
			bBmpLoaded = FALSE;
			EnableMenuItem( GetMenu( hWnd ), IDM_SAVEAS, MF_BYCOMMAND | MFS_GRAYED );
			EnableMenuItem( GetMenu( hWnd ), IDM_COPY, MF_BYCOMMAND | MFS_GRAYED );
			break;
		}

		case WM_ACTIVATE:
		{
			long lFlag = ( GetClipboardHBitmap( hWnd ) )? MFS_ENABLED : MFS_GRAYED ;
			EnableMenuItem( GetMenu( hWnd ), IDM_PASTE, MF_BYCOMMAND | lFlag );
			break;
		}

		case WM_COMMAND:
		{
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			switch (wmId)
			{
				case IDM_OPEN:
				{
					OPENFILENAME ofn;
					char lpstrFile[ MAX_PATH + 1 ] = "";
					memset( &ofn, 0, sizeof( OPENFILENAME ) );
					ofn.lStructSize = sizeof( OPENFILENAME );
					ofn.hwndOwner = hWnd;
					ofn.lpstrFilter = "Bitmap File (*.bmp)\0*.bmp\0\0";
					ofn.nFilterIndex = 1;
					ofn.lpstrFile = lpstrFile;
					ofn.nMaxFile = MAX_PATH;
					ofn.lpstrFileTitle = lpstrFileTitle;
					ofn.nMaxFileTitle = MAX_PATH;
					ofn.lpstrDefExt = "bmp";
					ofn.Flags = OFN_FILEMUSTEXIST;

					if( !GetOpenFileName( &ofn ) ) break;

					bBmpLoaded = FALSE;
					EnableMenuItem( GetMenu( hWnd ), IDM_SAVEAS, MF_BYCOMMAND | MFS_GRAYED );
					EnableMenuItem( GetMenu( hWnd ), IDM_COPY, MF_BYCOMMAND | MFS_GRAYED );

					hFile = CreateFile( lpstrFile,
						GENERIC_READ , FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );

					BITMAPFILEHEADER BmpFileHeader;
					DWORD dwActBytes;
					ReadFile( hFile, &BmpFileHeader, sizeof( BITMAPFILEHEADER ), &dwActBytes, NULL );

					if( BmpFileHeader.bfType != 0x4d42 )
					{
						MessageBox( hWnd, "Corrupted BMP file.", lpstrFileTitle, MB_ICONSTOP | MB_OK );
						CloseHandle( hFile );
						break;
					}

					BITMAPINFOHEADER BmpInfoHeader;
					ReadFile( hFile, &BmpInfoHeader, sizeof( BITMAPINFOHEADER ), &dwActBytes, NULL );

					if( BmpInfoHeader.biBitCount < 16 )
					{
						MessageBox( hWnd, "Not implemented yet: Use 16/24-bit BMP.", lpstrFileTitle, MB_ICONEXCLAMATION | MB_OK );
						CloseHandle( hFile );
						break;
					}

					GlobalUnlock( hMemBmpInfo );
					GlobalUnlock( hMemBmpImage );
					GlobalFree( hMemBmpInfo );
					GlobalFree( hMemBmpImage );

					hMemBmpInfo = GlobalAlloc( GHND, sizeof( BITMAPINFO ) );
					lpBmpInfo = (LPBITMAPINFO) GlobalLock( hMemBmpInfo );
					lpBmpInfo->bmiHeader = BmpInfoHeader;

					SetFilePointer( hFile, BmpFileHeader.bfOffBits, NULL, FILE_BEGIN );

					hMemBmpImage = GlobalAlloc( GHND, BmpFileHeader.bfSize - BmpFileHeader.bfOffBits );
					lpBmpImage = GlobalLock( hMemBmpImage );

					ReadFile( hFile, lpBmpImage, BmpFileHeader.bfSize - BmpFileHeader.bfOffBits, &dwActBytes, NULL );
					CloseHandle( hFile );
					bBmpLoaded = TRUE;

					EnableMenuItem( GetMenu( hWnd ), IDM_SAVEAS, MF_BYCOMMAND | MFS_ENABLED );
					EnableMenuItem( GetMenu( hWnd ), IDM_COPY, MF_BYCOMMAND | MFS_ENABLED );

					AdjustWindowSize( hWnd, BmpInfoHeader.biWidth, BmpInfoHeader.biHeight, &picRect );
					InvalidateRect( hWnd, NULL, TRUE );
					break;
				}

				case IDM_SAVEAS:
				{
					if( !bBmpLoaded ) break;

					OPENFILENAME ofn;
					char lpstrFile[ MAX_PATH + 1 ] = "";
					memset( &ofn, 0, sizeof( OPENFILENAME ) );
					ofn.lStructSize = sizeof( OPENFILENAME );
					ofn.hwndOwner = hWnd;
					ofn.lpstrFilter = "Bitmap File (*.bmp)\0*.bmp\0\0";
					ofn.nFilterIndex = 1;
					ofn.lpstrFile = lpstrFile;
					ofn.nMaxFile = MAX_PATH;
					ofn.lpstrFileTitle = lpstrFileTitle;
					ofn.nMaxFileTitle = MAX_PATH;
					ofn.lpstrDefExt = "bmp";
					ofn.Flags = OFN_PATHMUSTEXIST | OFN_OVERWRITEPROMPT;

					if( !GetSaveFileName( &ofn ) ) break;
					int nColorTable;
					switch( lpBmpInfo->bmiHeader.biBitCount )
					{
						case 1:         nColorTable =   2;    break;
						case 4:         nColorTable =  16;    break;
						case 8:         nColorTable = 256;    break;
						default:        nColorTable =   0;    break;
					}

					int cx = lpBmpInfo->bmiHeader.biWidth;
					int cy = lpBmpInfo->bmiHeader.biHeight;
					int nPaletteSize = sizeof(RGBQUAD) * nColorTable;
					int nPureDataSize = ((( cx * lpBmpInfo->bmiHeader.biBitCount ) + 31) / 8) * cy;

					BITMAPFILEHEADER bmfh;
					bmfh.bfType = 0x4d42; // 'BM'
					bmfh.bfSize = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + nPaletteSize + nPureDataSize;
					bmfh.bfReserved1 = 0;
					bmfh.bfReserved2 = 0;
					bmfh.bfOffBits = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + nPaletteSize;

					HANDLE hFile = CreateFile( ofn.lpstrFile,
						GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
					DWORD dwActBytes;
					WriteFile( hFile, &bmfh, sizeof( BITMAPFILEHEADER ), &dwActBytes, NULL );
					WriteFile( hFile, lpBmpInfo, sizeof( BITMAPINFOHEADER ) + nPaletteSize, &dwActBytes, NULL );
					WriteFile( hFile, lpBmpImage, nPureDataSize, &dwActBytes, NULL  );

					CloseHandle( hFile );
					break;
				}


				case IDM_COPY:
				{
					if( !bBmpLoaded ) break;

					int cx = lpBmpInfo->bmiHeader.biWidth;
					int cy = lpBmpInfo->bmiHeader.biHeight;
					if( cx > 720 ) cx = 720;
					if( cy > 480 ) cy = 480;
					HDC hDC = GetDC( hWnd );
					HDC hMemDC = CreateCompatibleDC( hDC );
					HBITMAP hBitmap = CreateCompatibleBitmap( hDC, cx, cy );
					SelectObject( hMemDC, hBitmap );
					BitBlt( hMemDC, 0, 0, cx, cy, hDC, 0, 0, SRCCOPY );
					OpenClipboard( hWnd );
					EmptyClipboard();
					SetClipboardData( CF_BITMAP, hBitmap );
					CloseClipboard();
					DeleteDC( hMemDC );
					ReleaseDC( hWnd, hDC );
					EnableMenuItem( GetMenu( hWnd ), IDM_PASTE, MF_BYCOMMAND | MFS_ENABLED );
					break;
				}
				case IDM_PASTE:
				case IDM_RELOAD:
				{
					long lFlag = ( GetClipboardHBitmap( hWnd ) )? MFS_ENABLED : MFS_GRAYED ;
					EnableMenuItem( GetMenu( hWnd ), IDM_PASTE, MF_BYCOMMAND | lFlag );

					if( lFlag == MFS_ENABLED )
					{
						bBmpLoaded = FALSE;
						EnableMenuItem( GetMenu( hWnd ), IDM_SAVEAS, MF_BYCOMMAND | MFS_GRAYED );
						EnableMenuItem( GetMenu( hWnd ), IDM_COPY, MF_BYCOMMAND | MFS_GRAYED );

						SetWindowText( hWnd, APP_NAME " (no data)" );
						InvalidateRect( hWnd, NULL, TRUE );
					}
					break;
				}
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		}

		case WM_MOUSEMOVE:
		{
			iMouseX = LOWORD( lParam );
			iMouseY = HIWORD( lParam );

			if( iMouseX < picRect.left || iMouseX > picRect.right
				|| iMouseY < picRect.top || iMouseY > picRect.bottom ) break;
			
			HDC hDC = GetDC( hWnd );
			colorref = GetPixel( hDC, iMouseX, iMouseY );
			ReleaseDC( hWnd, hDC );
			InvalidateRect( hWnd, &redrewRect, TRUE );
			break;
		}

		case WM_LBUTTONDOWN:
		{
			if( wParam & MK_RBUTTON )
			{
				char str[ 1024 ];

				iMouseX = LOWORD( lParam );
				iMouseY = HIWORD( lParam );

				if( iMouseX < picRect.left || iMouseX > picRect.right
					|| iMouseY < picRect.top || iMouseY > picRect.bottom ) break;

				HDC hDC = GetDC( hWnd );
				colorSamples[ 0 ] = GetPixel( hDC, iMouseX - 1, iMouseY - 1 );
				colorSamples[ 1 ] = GetPixel( hDC, iMouseX - 1, iMouseY );
				colorSamples[ 2 ] = GetPixel( hDC, iMouseX - 1, iMouseY + 1 );
				colorSamples[ 3 ] = GetPixel( hDC, iMouseX , iMouseY - 1 );
				colorSamples[ 4 ] = GetPixel( hDC, iMouseX , iMouseY );
				colorSamples[ 5 ] = GetPixel( hDC, iMouseX , iMouseY + 1 );
				colorSamples[ 6 ] = GetPixel( hDC, iMouseX + 1, iMouseY - 1 );
				colorSamples[ 7 ] = GetPixel( hDC, iMouseX + 1, iMouseY );
				colorSamples[ 8 ] = GetPixel( hDC, iMouseX + 1, iMouseY + 1 );
				ReleaseDC( hWnd, hDC );
				uSamplingIdx = 9;

				colorref = GetAverageColorref( colorSamples, 9 );
				wsprintf( str, "Average of the 9 pixels at and around the mouse cursor:\n\n"
					"&H%06x&\n(%u)", colorref, colorref );

				InvalidateRect( hWnd, &redrewRect2, TRUE );

				if( IDCANCEL == MessageBox( hWnd, str, "Sampling", MB_OKCANCEL | MB_ICONINFORMATION ) )
				{
					uSamplingIdx = 0;
					break;
				}
				flagSamplingReset = TRUE;

				if( wParam & MK_SHIFT )
				{
					wsprintf( szColorCode, "%lu", colorref );
				}
				else
				{
					wsprintf( szColorCode, "&H%06x&", colorref );
				}

				HGLOBAL hMemClipboardText = GlobalAlloc( GHND, 1024 );
				LPSTR lpszClipboardText = (LPSTR) GlobalLock( hMemClipboardText );
				lstrcpy( lpszClipboardText, szColorCode );

				if( OpenClipboard( hWnd ) )
				{
					EmptyClipboard();
					SetClipboardData( CF_TEXT, hMemClipboardText );
					CloseClipboard();
				}
				else MessageBox( hWnd, "OpenClipboard failed.", APP_NAME, MB_ICONSTOP | MB_OK );
				GlobalUnlock( hMemClipboardText );
				// Do not GlobalFree( hMemClipboardText ), clipboard data is shared and not ours anymore.

				EnableMenuItem( GetMenu( hWnd ), IDM_PASTE, MF_BYCOMMAND | MFS_GRAYED );
			}
			break;
		}


		case WM_LBUTTONUP:
		{
			if(	flagSamplingReset )
			{
				uSamplingIdx = 0;
				flagSamplingReset = FALSE;
			}
			
			char str[ 1024 ];

			iMouseX = LOWORD( lParam );
			iMouseY = HIWORD( lParam );

			if( iMouseX < picRect.left || iMouseX > picRect.right
				|| iMouseY < picRect.top || iMouseY > picRect.bottom ) break;

			HDC hDC = GetDC( hWnd );
			colorref = GetPixel( hDC, iMouseX, iMouseY );
			ReleaseDC( hWnd, hDC );

			if( uSamplingIdx > 0 && !( wParam & MK_RBUTTON ) )
			{
				colorref = GetAverageColorref( colorSamples, uSamplingIdx );

				InvalidateRect( hWnd, &redrewRect2, TRUE );

				wsprintf( str, "Average of %u Sample(s):\n&H%06x&\n(%u)", uSamplingIdx, colorref, colorref );
				if( IDCANCEL == MessageBox( hWnd, str, "Sampling", MB_OKCANCEL | MB_ICONINFORMATION ) )
				{
					uSamplingIdx = 0;
					break;
				}
				flagSamplingReset = TRUE;
			}
			
			if( wParam & MK_SHIFT )
			{
				wsprintf( szColorCode, "%lu", colorref );
			}
			else
			{
				wsprintf( szColorCode, "&H%06x&", colorref );
			}

			HGLOBAL hMemClipboardText = GlobalAlloc( GHND, 1024 );
			LPSTR lpszClipboardText = (LPSTR) GlobalLock( hMemClipboardText );
			lstrcpy( lpszClipboardText, szColorCode );

			if( OpenClipboard( hWnd ) )
			{
				EmptyClipboard();
				SetClipboardData( CF_TEXT, hMemClipboardText );
				CloseClipboard();
			}
			else MessageBox( hWnd, "OpenClipboard failed.", APP_NAME, MB_ICONSTOP | MB_OK );
			GlobalUnlock( hMemClipboardText );
			// Do not GlobalFree( hMemClipboardText ), clipboard data is shared and not ours anymore.

			EnableMenuItem( GetMenu( hWnd ), IDM_PASTE, MF_BYCOMMAND | MFS_GRAYED );

			break;
		}

		case WM_RBUTTONDOWN:
		{
			if( wParam & MK_LBUTTON )
			{
				SendMessage( hWnd, WM_LBUTTONDOWN, wParam & MK_RBUTTON, lParam );
			}
			break;
		}

		case WM_RBUTTONUP:
		{
				iMouseX = LOWORD( lParam );
				iMouseY = HIWORD( lParam );

				if( iMouseX < picRect.left || iMouseX > picRect.right
					|| iMouseY < picRect.top || iMouseY > picRect.bottom ) break;
			if(	flagSamplingReset )
			{
				uSamplingIdx = 0;
				flagSamplingReset = FALSE;
			}


			if( uSamplingIdx <= 11 )
			{
				iMouseX = LOWORD( lParam );
				iMouseY = HIWORD( lParam );
				HDC hDC = GetDC( hWnd );
				colorSamples[ uSamplingIdx++ ] = GetPixel( hDC, iMouseX, iMouseY );
				ReleaseDC( hWnd, hDC );
				InvalidateRect( hWnd, &redrewRect2, TRUE );
			}

			if( uSamplingIdx >= 12 )
			{
				SendMessage( hWnd, WM_LBUTTONUP, wParam, lParam );
			}

			break;
		}

		case WM_PAINT:
		{
			RECT clientRect;

			hdc = BeginPaint(hWnd, &ps);

			HFONT hFont = CreateFont( -MulDiv( 16, GetDeviceCaps( hdc, LOGPIXELSY ), 72 ),
				0, 0, 0, FW_BOLD, FALSE, FALSE, FALSE, ANSI_CHARSET,
				OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY,
				FIXED_PITCH | FF_MODERN, "Courier New" );
			HFONT hOldFont = (HFONT) SelectObject( hdc, hFont );

			if( !bBmpLoaded )
			{
				HBITMAP hBitmap = GetClipboardHBitmap( hWnd );

				if( hBitmap )
				{
					BITMAP bmap;
					GetObject( hBitmap, sizeof( BITMAP ), (LPSTR) &bmap );
					AdjustWindowSize( hWnd, bmap.bmWidth, bmap.bmHeight, &picRect );
					int nColorTable;
					switch( bmap.bmBitsPixel )
					{
						case 1:         nColorTable =   2;    break;
						case 4:         nColorTable =  16;    break;
						case 8:         nColorTable = 256;    break;
						default:        nColorTable =   0;    break;         
					}

					int nBmi = sizeof(RGBQUAD) * nColorTable;                                  
					int nImage = (((bmap.bmWidth * bmap.bmBitsPixel) + 31) / 8) * bmap.bmHeight;

					GlobalUnlock( hMemBmpInfo );
					GlobalUnlock( hMemBmpImage );
					GlobalFree( hMemBmpInfo );
					GlobalFree( hMemBmpImage );

					hMemBmpInfo = GlobalAlloc( GHND, sizeof( BITMAPINFO ) );
					hMemBmpImage = GlobalAlloc( GHND,  nBmi + nImage );
					lpBmpInfo = (LPBITMAPINFO) GlobalLock( hMemBmpInfo );
					lpBmpImage = GlobalLock( hMemBmpImage );

					lpBmpInfo->bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
					lpBmpInfo->bmiHeader.biWidth = bmap.bmWidth;
					lpBmpInfo->bmiHeader.biHeight = bmap.bmHeight;
					lpBmpInfo->bmiHeader.biPlanes = 1;
					lpBmpInfo->bmiHeader.biBitCount = bmap.bmBitsPixel;
					lpBmpInfo->bmiHeader.biCompression = BI_RGB;
					lpBmpInfo->bmiHeader.biSizeImage = 0;
					lpBmpInfo->bmiHeader.biXPelsPerMeter = 0;
					lpBmpInfo->bmiHeader.biYPelsPerMeter = 0;
					lpBmpInfo->bmiHeader.biClrUsed = nColorTable;
					lpBmpInfo->bmiHeader.biClrImportant = nColorTable;

					GetDIBits( hdc, hBitmap, 0, bmap.bmHeight, lpBmpImage, lpBmpInfo, DIB_RGB_COLORS );

					bBmpLoaded = TRUE;
					EnableMenuItem( GetMenu( hWnd ), IDM_SAVEAS, MF_BYCOMMAND | MFS_ENABLED );
					EnableMenuItem( GetMenu( hWnd ), IDM_COPY, MF_BYCOMMAND | MFS_ENABLED );

					lstrcpy( lpstrFileTitle , "(Clipboard)" );

				}
			}

			GetClientRect( hWnd, &clientRect );

			if( bBmpLoaded )
			{
				HDC hMemDC = CreateCompatibleDC( hdc );
				HBITMAP hDIB = CreateDIBitmap( hdc, &(lpBmpInfo->bmiHeader), CBM_INIT,
						lpBmpImage, lpBmpInfo, DIB_RGB_COLORS );

				HBITMAP hOldDIB = (HBITMAP) SelectObject( hMemDC, hDIB );
				int cx = lpBmpInfo->bmiHeader.biWidth;
				if( cx > 720 ) cx = 720;
				int cy = lpBmpInfo->bmiHeader.biHeight;
				if( cy > 480 ) cy = 480;
				BitBlt( hdc, 0, 0, cx, cy, hMemDC, 0, 0, SRCCOPY );

				SelectObject( hdc, hOldDIB );
				DeleteObject( hDIB );
				DeleteDC( hMemDC );
			}
//			else
//			{
//				SetTextColor( hdc, RGB( 0xFF, 0, 0 ) );
//				char str[ 1024 ] = "No Bitmap data in Clipbaord.";
//				TextOut( hdc, 10, 10, str, lstrlen( str ) );
//			}

			redrewRect.left = 18;
			redrewRect.top = clientRect.bottom - 152;
			redrewRect.right = 112;
			redrewRect.bottom = clientRect.bottom - 30;

			redrewRect2.left = 15;
			redrewRect2.top = clientRect.bottom - 152;
			redrewRect2.right = 500;
			redrewRect2.bottom = clientRect.bottom - 58;

			wsprintf( szColorCode, "&H%02x%02x%02x&", GetBValue( colorref ), GetGValue( colorref ), GetRValue( colorref ) );

			SetTextColor( hdc, RGB( 0, 0, 0xff ) );
			TextOut( hdc, 5, clientRect.bottom - 50, szColorCode, lstrlen( szColorCode ) );
			HRGN hRgn  = CreateRoundRectRgn( 20, clientRect.bottom - 150, 110, clientRect.bottom - 60, 30, 30 );
			HRGN hRgn2 = CreateRoundRectRgn( 19, clientRect.bottom - 151, 111, clientRect.bottom - 59, 30, 30 );

			HBRUSH hBrush = CreateSolidBrush( RGB( 0xa0, 0xa0, 0xa0 ) );
			FillRgn( hdc, hRgn2, hBrush );

			hBrush = CreateSolidBrush( colorref );
			FillRgn( hdc, hRgn, hBrush );

			HDC hMemDC = CreateCompatibleDC( hdc );
			HBITMAP hOldDIB = (HBITMAP) SelectObject( hMemDC, hShia );
#ifdef SHIA_SPECIAL
			BitBlt( hdc, clientRect.right - 88, clientRect.bottom - 128, 88, 128, hMemDC, 0, 0, SRCCOPY );
#else
			BitBlt( hdc, clientRect.right - 52, clientRect.bottom - 67, 52, 67, hMemDC, 0, 0, SRCCOPY );
#endif
			SelectObject( hdc, hOldDIB );
			DeleteDC( hMemDC );

			if( uSamplingIdx > 0 )
			{
				HFONT hFont2 = CreateFont( -MulDiv( 16, GetDeviceCaps( hdc, LOGPIXELSY ), 72 ),
				0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, ANSI_CHARSET,
				OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY,
				FIXED_PITCH | FF_MODERN, "Courier New" );
				SelectObject( hdc, hFont2 );
				char str[ 1024 ];
				unsigned int i;
				for( i = 0; i < uSamplingIdx; i++ )
				{
					int x = 150 + 90 * ( i / 4 );
					int y = clientRect.bottom - 150 + 20 * ( i % 4 );
					wsprintf( str, "%06x", colorSamples[ i ] );
					TextOut( hdc, x, y, str, lstrlen( str ) );
				}
				SelectObject( hdc, hFont );
				DeleteObject( hFont2 );
			}


			DeleteObject( hRgn );
			DeleteObject( hBrush );
			SelectObject( hdc, hOldFont );
			DeleteObject( hFont );

			EndPaint(hWnd, &ps);

			char str[ 1024 ];
			wsprintf( str, "%s - %s", APP_NAME, lpstrFileTitle );
			SetWindowText( hWnd, str );
			break;
		}

		case WM_DESTROY:
		{
			DeleteObject( hShia );
			GlobalUnlock( hMemBmpInfo );
			GlobalFree( hMemBmpInfo );
			GlobalUnlock( hMemBmpImage );
			GlobalFree( hMemBmpImage );

			PostQuitMessage(0);
			break;
		}
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
		{
			char str[ 1024 ];
			wsprintf( str, "%s : %s +0900", __DATE__, __TIME__ );
			SetDlgItemText( hDlg, IDC_VERSION , APP_NAME );
			SetDlgItemText( hDlg, IDC_DATETIME , str );
			return TRUE;
		}
		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
